(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"), require("react-emotion"), require("@emotion/is-prop-valid"));
	else if(typeof define === 'function' && define.amd)
		define(["react", "react-emotion", "@emotion/is-prop-valid"], factory);
	else if(typeof exports === 'object')
		exports["Subatomic"] = factory(require("react"), require("react-emotion"), require("@emotion/is-prop-valid"));
	else
		root["Subatomic"] = factory(root["react"], root["react-emotion"], root["@emotion/is-prop-valid"]);
})(typeof self !== 'undefined' ? self : this, function(__WEBPACK_EXTERNAL_MODULE_0__, __WEBPACK_EXTERNAL_MODULE_7__, __WEBPACK_EXTERNAL_MODULE_8__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 6);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_0__;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createSubatomic = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = __webpack_require__(0);

var _react2 = _interopRequireDefault(_react);

var _blacklistedStyleProps = __webpack_require__(2);

var _blacklistedStyleProps2 = _interopRequireDefault(_blacklistedStyleProps);

var _pseudoclasses = __webpack_require__(3);

var _pseudoclasses2 = _interopRequireDefault(_pseudoclasses);

var _default = __webpack_require__(4);

var _default2 = _interopRequireDefault(_default);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var isBlacklistedStyleProp = function isBlacklistedStyleProp(prop) {
  return _blacklistedStyleProps2.default.indexOf(prop) >= 0;
};

var customPropsCached = void 0;

// Cache for styled components (so we're not creating new ones on each render)
var Cache = createCache();

var createSubatomic = function createSubatomic(tag, getComponent, isValidAttribute) {
  var defaultOptions = {
    themeBreakpointsKey: "breakpoints",
    tagProp: "is"
  };

  var options = defaultOptions;

  // TODO: Let consumer pass in custom options to createSubatomic
  /*if (options) {
    options = Object.assign(defaultOptions, options);
  } else {
    options = defaultOptions;
  }*/

  // The returned stateless functional component
  var Subatomic = function Subatomic(_ref) {
    var allProps = _objectWithoutProperties(_ref, []);

    // Destructure tagProp from props and assign value to "is" variable
    var is = allProps[options.tagProp],
        props = _objectWithoutProperties(allProps, [options.tagProp]);

    // "is" prop overrides tag so we can change element


    if (is) {
      tag = is;
    }

    // Will be the returned react component
    var Component = getComponentWithCache(tag, options, getComponent, isValidAttribute);

    // Save Component to cache
    Cache.put(tag, Component);

    return _react2.default.createElement(Component, props);
  };

  return Subatomic;
};

exports.createSubatomic = createSubatomic;
function getComponentWithCache(tag, options, getComponent, isValidAttribute) {
  // Get component from cache by its tag (tag can be string or function reference)
  var CachedComponent = Cache.get(tag);
  if (CachedComponent) {
    return CachedComponent;
  }

  var styleBuilder = createStyleBuilder(options, isValidAttribute);

  // Get the cache index Component will have once it's added to cache
  // Used to create a deterministic hash for className (since will be same across server and client)
  // If tag is a string then value will be null (not needed)
  var referenceCacheIndex = null;
  if ((typeof tag === "undefined" ? "undefined" : _typeof(tag)) === "object") {
    var cache = Cache.get();
    referenceCacheIndex = cache.byReference.keys.length;
  }

  var Component = getComponent(tag, styleBuilder, referenceCacheIndex);

  // Save Component to cache
  Cache.put(tag, Component);

  return Component;
}

function createStyleBuilder(options, isValidAttribute) {
  var styleBuilder = function styleBuilder(allProps) {
    // If theme passed via ThemeProvider then use it!
    // If not then allProps.theme will be an empty object
    var theme = void 0;
    if (isEmptyObject(allProps.theme) === false) {
      theme = allProps.theme;
    } else if (!theme) {
      // Otherwise use our basic default theme
      theme = _default2.default;
    }

    var customProps = void 0;
    if (customPropsCached) {
      customProps = customPropsCached;
    } else {
      customProps = createPropVariations(theme.props);
      customPropsCached = customProps;
    }

    // TODO: memoize?
    var breakpoints = getBreakpoints(theme, options);

    var buildStyleFromObject = function buildStyleFromObject(props) {
      var fromPseudoClassObject = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var allStyles = {};

      // Iterate through the component's props

      var _loop = function _loop() {
        var prop = props[propName];
        var propType = typeof prop === "undefined" ? "undefined" : _typeof(prop);

        // Skip this style prop if blacklisted (not a style prop)
        // Or if not a custom style prop and it is a valid attribute
        if (isBlacklistedStyleProp(propName) || !customProps[propName] && isValidAttribute(propName)) {
          return "continue";
        }

        // Get the prop's config
        var config = customProps[propName] || propName;

        // Make config an object if string
        // Could be string if using shorthand or values in pseudoClass style
        if (typeof config === "string") {
          config = {
            style: config
          };
        }

        // See if prop is a pseudoclass (hoverColor, hoverPlaceholderColor)
        // Skip if custom style prop in config
        if (!customProps[propName]) {
          var wasPseudoclass = false;
          // Iterate through pseudoclasses (also contains pseudoelements)
          for (var key in _pseudoclasses2.default) {
            var pseudo = key;
            // Check if string starts with pseudoclass
            if (propName.startsWith(pseudo)) {
              // Get the portion after the pseudoclass
              var remainder = propName.slice(pseudo.length);
              remainder = remainder.charAt(0).toLowerCase() + remainder.slice(1);
              // Prefix with : or :: depending on whether class or element
              var pseudoPrefixed = (_pseudoclasses2.default[key] === "class" ? ":" : "::") + pseudo;
              // Recursively call build style on remaining portion as a prop
              var result = buildStyleFromObject(_defineProperty({}, remainder, prop), true);
              // Add to allStyles (or merge if already populated by another prop with same psuedoclass)
              if (allStyles[pseudoPrefixed]) {
                allStyles[pseudoPrefixed] = Object.assign(allStyles[pseudoPrefixed], result);
              } else {
                allStyles[pseudoPrefixed] = result;
              }

              wasPseudoclass = true;
              continue;
            }
          }

          // Continue because pseudoclass style already generated from recursive call
          if (wasPseudoclass) return "continue";
        }

        // No longer doing pseudoclass object syntax
        /*
        if (config.pseudoClass) {
          allStyles[config.pseudoClass] = buildStyleFromObject(prop, true);
          continue;
        }
        */

        // Function that looks up prop value in theme
        var getFromTheme = function getFromTheme(value) {
          // Convert value to positive if a negative number
          var posValue = isNegative(value) ? value * -1 : value;
          // Construct dot notation key to actual value in theme
          var fullKey = config.themeKey + "." + posValue;
          // Get value from theme
          var themeValue = get(theme, fullKey);
          // If value from theme is a number and input value was negative ...
          // ... then make the theme value negative
          if (isNegative(value) && isNumber(themeValue)) {
            themeValue = themeValue * -1;
          }
          return themeValue;
        };

        // Make props value an array if it's not
        var propValues = Array.isArray(prop) ? prop : [prop];

        // Iteration through props value array
        for (var i = 0; i < propValues.length; i++) {
          var propValue = propValues[i];

          // If no prop value is boolean true (example: <Flex wrap>)
          // Then set it to defaultValue if specified
          if (config.defaultValue && propValue === true) {
            propValue = config.defaultValue;
          }

          // Prop value might be a key for actual value in theme
          propValue = config.themeKey && getFromTheme(propValue) || propValue;

          // Append unit to propValue if number and defaultUnit specified
          if (config.defaultUnit && isNumber(propValue)) {
            propValue = "" + propValue + config.defaultUnit;
          }

          var styleObj = void 0;
          if (typeof config === "string") {
            styleObj = makeStyle(propValue, config);
          } else if (typeof config.style === "function") {
            styleObj = config.style(propValue, propName);
          } else {
            // Otherwise assume config.style is string or array
            styleObj = makeStyle(propValue, config.style);
          }

          if (i === 0) {
            // Merge with rest of component's styles
            Object.assign(allStyles, styleObj);
          } else {
            // Any prop values after the first get wrapped in media query
            var bp = breakpoints[i - 1];
            if (!allStyles[bp]) allStyles[bp] = {};
            Object.assign(allStyles[bp], styleObj);
          }
        }
      };

      for (var propName in props) {
        var _ret = _loop();

        if (_ret === "continue") continue;
      }

      return allStyles;
    };

    return buildStyleFromObject(allProps);
  };

  return styleBuilder;
}

// Accepts a single css property (string) or multiple (array)
// Returns a style object with
function makeStyle(value, cssProperty) {
  var styleObj = {};
  // Ensure we have an array of css properties
  var cssProperties = Array.isArray(cssProperty) ? cssProperty : [cssProperty];
  // Iterate through cssProperties and build styleObj
  cssProperties.forEach(function (p) {
    return styleObj[p] = value;
  });
  return styleObj;
}

function createPropVariations(props) {
  for (var key in props) {
    var _prop = props[key];
    if (_prop.variations) {
      for (var vKey in _prop.variations) {
        var style = _prop.style,
            variations = _prop.variations,
            newProp = _objectWithoutProperties(_prop, ["style", "variations"]);

        newProp.style = variations[vKey];
        props[vKey] = newProp;
      }
    }
  }
  return props;
}

function getBreakpoints(theme, options) {
  return theme[options.themeBreakpointsKey].map(function (bp) {
    return "@media screen and (min-width: " + bp + ")";
  });
}

function isNumber(value) {
  return typeof value === "number" && !isNaN(value);
}

function isNegative(value) {
  return isNumber(value) && value < 0;
}

// Returns a cache object where key can be string or object/function reference
function createCache() {
  var cache = {
    byString: {},
    byReference: {
      keys: [],
      values: []
    }
  };
  return {
    put: function put(key, value) {
      if ((typeof key === "undefined" ? "undefined" : _typeof(key)) === "object") {
        var index = cache.byReference.keys.indexOf(key);
        if (index === -1) {
          cache.byReference.keys.push(key);
          cache.byReference.values.push(value);
        } else {
          cache.byReference.values[index] = value;
        }
      } else {
        cache.byString[key] = value;
      }
    },
    get: function get(key) {
      if (!key) {
        return cache;
      } else if ((typeof key === "undefined" ? "undefined" : _typeof(key)) === "object") {
        var index = cache.byReference.keys.indexOf(key);
        return cache.byReference.values[index];
      } else {
        return cache.byString[key];
      }
    }
  };
}

// lodash.get alternative (much smaller file size)
// From https://gist.github.com/jeneg/9767afdcca45601ea44930ea03e0febf
function get(obj, path, def) {
  var fullPath = path.replace(/\[/g, ".").replace(/]/g, "").split(".").filter(Boolean);

  return fullPath.every(everyFunc) ? obj : def;

  function everyFunc(step) {
    return !(step && (obj = obj[step]) === undefined);
  }
}

var isEmptyObject = function isEmptyObject(obj) {
  return Object.keys(obj).length === 0 && obj.constructor === Object;
};

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
// Props that are neither attributes or style props
exports.default = [
// React
"theme", "children",
// Subatomic Emotion
"parentClassName"];

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = {
  active: 'class',
  checked: 'class',
  disabled: 'class',
  empty: 'class',
  enabled: 'class',
  focus: 'class',
  hover: 'class',
  invalid: 'class',
  required: 'class',
  target: 'class',
  valid: 'class',
  after: 'element',
  before: 'element',
  placeholder: 'element',
  selection: 'element'
};

/***/ }),
/* 4 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
//prettier-ignore
/* harmony default export */ __webpack_exports__["default"] = ({
  breakpoints: ['576px', '768px', '992px', '1200px'],
  space: [0, 4, 8, 16, 32, 64, 128, 256, 512 ],
  fontSizes: [12, 14, 16, 20, 24, 32, 48, 64, 72],
  // Custom style props go in the props object
  props: {
    f: {
      // Where to find values in theme
      themeKey: 'fontSizes',
      // Default unit if none specified
      defaultUnit: 'px',
      // Resulting css property
      style: 'fontSize'
    },
    color: {
      // Extend theme and add colors object
      themeKey: 'colors',
      style: 'color'
    },
    bg: {
      themeKey: 'colors',
      style: 'backgroundColor'
    },
    borderColor: {
      themeKey: 'colors',
      style: 'borderColor'
    },
    d: {
      style: 'display'
    },
    p: {
      themeKey: 'space',
      defaultUnit: 'px',
      style: 'padding',
      // Directional variations
      variations: {
        pt: 'paddingTop',
        pr: 'paddingRight',
        pb: 'paddingBottom',
        pl: 'paddingLeft',
        px: ['paddingLeft', 'paddingRight'],
        py: ['paddingTop', 'paddingBottom']
      }
    },
    m: {
      themeKey: 'space',
      defaultUnit: 'px',
      style: 'margin',
      variations: {
        mt: 'marginTop',
        mr: 'marginRight',
        mb: 'marginBottom',
        ml: 'marginLeft',
        mx: ['marginLeft', 'marginRight'],
        my: ['marginTop', 'marginBottom']
      }
    },
    h: {
      style: 'height'
    },
    // Advanced width prop
    w: {
      // Style is a function instead of a string
      style: value => {
        let width = value;
        // If less than 1 make it a fraction of 100% (1/3 = 33.33...%, etc)
        // Nice for column widths (<Row><Col w={1/3}><Col w={2/3}></Row>)
        if (isNumber(width) && width <= 1) {
          width = `${width * 100}%`;
        }
        return {
          width: width
        };
      }
    }
  }
});

const isNumber = n => typeof n === "number" && !isNaN(n);


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
// These are valid attributes but we consider them style props instead
// TODO: Allow them to be passed to html element by doing attrColor
// TODO (?): Replace attribute whitelist with react-html-attributes so that attributes ...
// ... are considered invalid (and thus style props) if not valid for that element
// Then we could remove any of these where attribute has same effect as css property for the given element
// See how Glamorous does it: https://github.com/paypal/glamorous/blob/6d806889e9991065f1243d4abdce9c0b6cd3a2ae/src/should-forward-property.js
exports.default = ["color", // link, svg
"cursor", // svg
"display", // svg
"fontFamily", // svg
"fontSize", // svg
"fontStyle", // svg
"fontWeight", // svg
"height", // applet, canvas, embed, iframe, img, input, object, td, th, video
"width", // applet, canvas, col, colgroup, embed, hr, iframe, img, input, object, pre, table, td, th, video
"letterSpacing", // svg
"opacity", // svg
"order", // svg
"overflow", // svg
"size", // basefont, font, hr, input, select
"scale", // svg
"textDecoration", // svg
"transform" // svg
];

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _templateObject = _taggedTemplateLiteral(["\n    ", "\n  "], ["\n    ", "\n  "]);

var _react = __webpack_require__(0);

var _react2 = _interopRequireDefault(_react);

var _reactEmotion = __webpack_require__(7);

var _reactEmotion2 = _interopRequireDefault(_reactEmotion);

var _subatomic = __webpack_require__(1);

var _isPropValid = __webpack_require__(8);

var _isPropValid2 = _interopRequireDefault(_isPropValid);

var _blacklistedAttributes = __webpack_require__(5);

var _blacklistedAttributes2 = _interopRequireDefault(_blacklistedAttributes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

exports.default = function (tag) {
  return function (props) {
    var Subatomic = createSubatomic(tag);
    return _react2.default.createElement(Subatomic, props);
  };
};

function createSubatomic(tag) {
  return (0, _subatomic.createSubatomic)(tag, getComponent,
  // Pass in so we can re-use emotion whitelist for lower bundle size
  isValidAttribute);
}

function getComponent(tag, // string or component
styleBuilder) {
  var createStyled = void 0;

  if (typeof tag === "string") {
    // We now filter using isValidAttribute()
    //const Root = styled(tag); // So whitelist filters out invalid element attributes

    var Filter = function Filter(_ref) {
      var parentClassName = _ref.parentClassName,
          props = _objectWithoutProperties(_ref, ["parentClassName"]);

      // Only pass props to DOM element if they are valid html attributes
      var next = {};
      for (var key in props) {
        if (isValidAttribute(key)) {
          next[key] = props[key];
        }
      }

      var className = next.className,
          passProps = _objectWithoutProperties(next, ["className"]);

      return _react2.default.createElement(tag, _extends({
        // This seems to work fine, but for now merging
        //className: `${parentClassName} ${className}`,
        // Merge to avoid any possible ordering issues
        className: (0, _reactEmotion.cx)(parentClassName, className)
      }, passProps));

      // No longer created a root element wrapped with styled() because we do filtering above
      //return <Root {...passProps} className={cx(parentClassName, className)} />;
    };

    createStyled = (0, _reactEmotion2.default)(Filter);
  } else {
    //createStyled = styled(tag);
    // This seems to work (at least with emotion)
    // I think with styled components there was some style ordering issue with just returning the tag
    // NOTE: If component (tag) doesn't have a subatomic element at its root then style props will have no effect
    return tag;
  }

  var Component = createStyled(_templateObject, styleBuilder);

  if (typeof tag === "string") {
    // Wrap with function so we can split off className
    var ComponentWrapper = function ComponentWrapper(props) {
      // Pass className as parentClassName so emotion doesn't merge styles
      // Then within Filter we use cx() to merge classNames with order reversed ...
      // ... so that the className from style props takes precedence
      var className = props.className,
          passProps = _objectWithoutProperties(props, ["className"]);

      return _react2.default.createElement(Component, _extends({
        parentClassName: className
      }, passProps));
    };
    return ComponentWrapper;
  } else {
    return Component;
  }
}

function isValidAttribute(attribute) {
  return (0, _isPropValid2.default)(attribute) && _blacklistedAttributes2.default.indexOf(attribute) === -1;
}

/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_7__;

/***/ }),
/* 8 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_8__;

/***/ })
/******/ ]);
});